import java.util.Scanner;
import java.util.ArrayList;

public class Capturacao{
	//Inteiro global para guardar o valor máximo de peças que podem ser capturadas
	static	int max=0;
	//Array List Global que guardará as coordenadas para cado caso de teste. Ao final de um caso de teste ela é limpa
	static ArrayList<int[]> Sol=new ArrayList<int[]>();
	
	public static void main (String args[]){
	
	Scanner sc = new Scanner(System.in);
		int x, y;
		x=sc.nextInt();
		y=sc.nextInt();	
				
		while(x!=0 && y!=0){


			int tabuleiro[][] = new int[x][y];
			int tab_val[][] = new int[x][y];
			int ax=0;
			int c=1;
			
			
			//Preenchimento do tabuleiro com base na enumeração das casas.
			for(int i =tabuleiro.length-1;i>=0;i--){										
				for(int j =0;j<tabuleiro[0].length;j++){				
					if(ax%2!=0 ){
						if(j%2!=0){
							tabuleiro[i][j]=sc.nextInt();														
							tab_val[i][j]=c;
							c++;
						}
						else{
							tabuleiro[i][j]=-1;			
							tab_val[i][j]=-1;
						}
					}
					else{
						if(j%2==0) {
							tabuleiro[i][j]=sc.nextInt();
							tab_val[i][j]=c;
							c++;
						}
						else{
							tabuleiro[i][j]=-1;									
							tab_val[i][j]=-1;
						}
				
					}									
				}
				ax++;
			}								
			max=0;					
			//Limpeza da lista que guardará as coordenadas
			Sol=new ArrayList<int[]>();	

			for(int j =0;j<tabuleiro.length;j++){
										
				for(int i =0;i<tabuleiro[0].length;i++){
					if(tabuleiro[j][i]==1){
						//Necessário criar uma cópia pq se existem mais de uma peça que pode fazer captura, o estado do tabuleiro não pode ser alterado por uma jogada de outra peça
						conta(j,i, copia(tabuleiro),0,new ArrayList<int[]>());										
					} 
				}
			
			}	
			//Imprime o valor maximo de captura
			System.out.println(max);
			//Imprime as coordenadas 
			if(max>0){
				for (int[] i: Sol){
					System.out.println(i[0]+ " "+ i[1]);
				}
			}
			x=sc.nextInt();
			y=sc.nextInt();
		}

		sc.close();
	}	
	
	static void conta(int x,int y, int tabuleiro[][], int cont,ArrayList<int[]> lista){	


		if(cont==0){
			//Ao sair da casa inicial, ela ficará livre e voce poderá passar por ela em outra jogada
			tabuleiro [x][y] = 0;		
			int ini[] = new int[2];
			ini[0]=x;
			ini[1]=y;
			lista.add(ini);
		}
		//Se achou novo máximo, atualiza tudo
		if (cont> max){
			
			max = cont;									
			Sol.clear();
			for(int i =0;i<lista.size();i++){
				Sol.add(lista.get(i));			
			}
			
		
		}
		//Se achou máximo parcial igual ao máximo global, verifica qual possui maior valor de impacto
		else if(cont==max){
			if(valor(lista)>valor(Sol)){
				Sol.clear();
				for(int i =0;i<lista.size();i++){
					Sol.add(lista.get(i));			
				}
			}
		
		}
		
		//a logica é similar para todos os movimentos feitos, alterando somente as coordenadas
		
		//Verifica se é possível capturar na diagonal superior esquerda
		if( (x-2 >=0) && (y-2 >=0) && (tabuleiro[x-1][y-1]==2)  && ( tabuleiro[x-2][y-2]==0) ){			
			//remove a peça capturada do tabuleiro
			tabuleiro [x-1][y-1] = -1;
			int se[] = new int[2];
			se[0]=x-2;
			se[1]=y-2;
			//adicionam coordenadas na lista
			lista.add(se);
			//chama a execução novamente para a peça apos o movimento de captura
			conta( x-2,y-2, tabuleiro, cont+1,lista);
			//devolve a peça no tabuleiro, para ser possível verificar outras jogadas que capturariam essa peça
			tabuleiro [x-1][y-1] = 2;
			//remove coordenadas da lista
			
			lista.remove(se);
			
		} 
		//Verifica se é possível capturar na diagonal superior direita
		if( (x-2 >=0) && (y+2 < tabuleiro[0].length) && (tabuleiro[x-1][y+1]==2)  && ( tabuleiro[x-2][y+2]==0) ){

			int sd[] = new int[2];
			sd[0]=x-2;
			sd[1]=y+2;
			lista.add(sd);
			tabuleiro [x-1][y+1] = -1;
			conta( x-2,y+2, tabuleiro, cont+1,lista);
			tabuleiro [x-1][y+1] = 2;
			lista.remove(sd);

		} 
		//Verifica se é possível capturar na diagonal inferior esquerda
		if( (x+2 < tabuleiro.length) && (y-2 >=0) && (tabuleiro[x+1][y-1]==2)  && ( tabuleiro[x+2][y-2]==0) ){

		

			int ie[] = new int[2];
			ie[0]=x+2;
			ie[1]=y-2;
			lista.add(ie);
			tabuleiro [x+1][y-1] = -1;
			conta( x+2,y-2, tabuleiro, cont+1,lista);
			tabuleiro [x+1][y-1] = 2;
			lista.remove(ie);
		}		
		//Verifica se é possível capturar na diagonal inferior direita
		if( (x+2 < tabuleiro.length) && (y+2 < tabuleiro[0].length) && (tabuleiro[x+1][y+1]==2)  && ( tabuleiro[x+2][y+2]==0) ){

			int id[] = new int[2];
			id[0]=x+2;
			id[1]=y+2;
			lista.add(id);
			tabuleiro [x+1][y+1] = -1;

			conta( x+2,y+2, tabuleiro, cont+1,lista);
			tabuleiro [x+1][y+1] = 2;
			lista.remove(id);
		} 

	}
	//cria cópia do tabuleiro para que o original não seja alterado
	static int [][] copia(int a[][]){
		int b[][] = new int[a.length][a[0].length];
		for(int i =0;i<a.length;i++){
			for(int j =0;j<a[0].length;j++){
			b[i][j]=a[i][j];
			}
		}
		return b;
	}
	//calcula valor de impacto de uma jogada
	static int valor(ArrayList<int[]> lista){				
		int resp=0;		
		int aux=1;				
		for(int[] i: lista){		
			resp+=((i[0]+i[1])*aux);
			aux++;
		}						
		return resp;
	}
}
